/* onode.h
   -------

   Header for O-Node Manipulation

   $Id: onode.h,v 1.9 2003/10/20 07:18:11 stewart Exp $
   
   (C)2003 Stewart Smith
   Distributed under the GNU Public License
 */

#ifndef __ONODE_H__
#define __ONODE_H__

#include "testkit/types.h"

struct fcfs_onode1 *onode1_new(struct fcfs_disk *disk);
struct fcfs_onode1 *onode1_free(struct fcfs_onode1 *onode);
int onode1_fork_new(struct fcfs_disk *disk, struct fcfs_block_run *onode_br, u64 fork_type, u64 content_length, void* content, int allow_internal);
int onode1_fork_grow(struct fcfs_disk *disk, struct fcfs_block_run *onode_br, int forknr, u64 blocksnr);

u64 onode1_fork_length(struct fcfs_onode1 *onode,int forknr);
int onode1_fork_write_versioned(struct fcfs_disk *disk,struct fcfs_onode1 *onode,  struct fcfs_block_run *onode_br,int forknr,u64 pos,u64 content_length,void* content);
int onode1_fork_write(struct fcfs_disk *disk, struct fcfs_block_run *onode_br,int forknr, u64 pos, u64 content_length, void* content);
u64 onode1_fork_read(struct fcfs_disk *disk, struct fcfs_onode1 *onode,int forknr, u64 pos, u64 content_length, void* content);
struct fcfs_disk_block *onode1_fork_getblock(struct fcfs_disk *disk, struct fcfs_onode1 *onode,int forknr,u64 blocknr);

#endif
